#include "PlugChan.h"

// RXgN^̒g
PlugChan::PlugChan(void)
{
	cout << "vORXgN^ʉ" << endl;
	setup();
}


PlugChan::~PlugChan(void)
{
}

// gݗĂs֐({)
void PlugChan::setup(void)
{
	//
	Head.setSize(40.0, 15.0, 20.0);
	Ear.setSize(5.0, 15.0, 10.0);
	Eye.setRadius(2.0);
	Eye.setDivide(2);
	Tail.setRadius(5.0);
	Tail.setDivide(2);

	EyeModel[0].setShape(&Eye);
	EyeModel[0].setMaterial(Red);
	EyeModel[0].glMoveTo(10.0, 0.0, 10.0);
	EyeModel[0].setParent(&HeadModel);
	EyeModel[1].setShape(&Eye);
	EyeModel[1].setMaterial(Red);
	EyeModel[1].glMoveTo(-10.0, 0.0, 10.0);
	EyeModel[1].setParent(&HeadModel);

	EarModel[0].setShape(&Ear);
	EarModel[0].setMaterial(Yellow);
	EarModel[0].glMoveTo(10.0, 15.0, 5.0);
	EarModel[0].setParent(&HeadModel);
	EarModel[1].setShape(&Ear);
	EarModel[1].setMaterial(Yellow);
	EarModel[1].glMoveTo(-10.0, 15.0, 5.0);
	EarModel[1].setParent(&HeadModel);

	HeadModel.setShape(&Head);
	HeadModel.setMaterial(White);
	HeadModel.glMoveTo(0.0, 40.0, 0.0);
	HeadModel.setParent(&RabbitModel);

	//
	Body.setSize(20.0, 20.0, 15.0);
	Arm.setSize(15.0, 5.0, 5.0);
	Leg.setSize(5.0, 20.0, 5.0);

	BodyModel.setShape(&Body);
	BodyModel.setMaterial(Blue);
	BodyModel.glMoveTo(0.0, 20.0, 0.0);

	TailModel.setShape(&Tail);
	TailModel.setMaterial(White);
	TailModel.glMoveTo(0.0, -8.0, -10.0);
	TailModel.setParent(&BodyModel);

	ArmModel[0].setShape(&Arm);
	ArmModel[0].setMaterial(White);
	ArmModel[0].glMoveTo(13.0, 3.0, 0.0);
	ArmModel[0].glAngle(0.0, 0.0, -8.7);
	ArmModel[0].setParent(&BodyModel);
	ArmModel[1].setShape(&Arm);
	ArmModel[1].setMaterial(White);
	ArmModel[1].glMoveTo(-13.0, 3.0, 0.0);
	ArmModel[1].glAngle(0.0, 0.0, 8.7);
	ArmModel[1].setParent(&BodyModel);

	LegModel[0].setShape(&Leg);
	LegModel[0].setMaterial(AshGray);
	LegModel[0].glMoveTo(5.0, -20.0, 0.0);
	LegModel[0].setParent(&BodyModel);
	LegModel[1].setShape(&Leg);
	LegModel[1].setMaterial(AshGray);
	LegModel[1].glMoveTo(-5.0, -20.0, 0.0);
	LegModel[1].setParent(&BodyModel);

	BodyModel.setParent(&RabbitModel);
	RabbitModel.glMoveTo(0.0, 5.0, 0.0);

	// tH[XVGbg
	BackPack.setSize(15.0, 10.0, 10.0);
	MainWing.setSize(40.0, 3.0, 10.0);
	TailWing.setSize(3.0, 25.0, 10.0);

	SilhouetteModel.setShape(&BackPack);
	SilhouetteModel.setMaterial(Red);
	SilhouetteModel.glMoveTo(0.0, 5.0, -15.0);
	SilhouetteModel.setParent(&BodyModel);
	WingModel[0].setShape(&MainWing);
	WingModel[0].setMaterial(Red);
	WingModel[0].glMoveTo(25.0, 5.0, 0.0);
	WingModel[0].setParent(&SilhouetteModel);
	WingModel[1].setShape(&MainWing);
	WingModel[1].setMaterial(Red);
	WingModel[1].glMoveTo(-25.0, 5.0, 0.0);
	WingModel[1].setParent(&SilhouetteModel);
	TailWingModel[0].setShape(&TailWing);
	TailWingModel[0].setMaterial(Red);
	TailWingModel[0].glMoveTo(6.0, -16.0, -2.0);
	TailWingModel[0].setParent(&SilhouetteModel);
	TailWingModel[1].setShape(&TailWing);
	TailWingModel[1].setMaterial(Red);
	TailWingModel[1].glMoveTo(-6.0, -16.0, -2.0);
	TailWingModel[1].setParent(&SilhouetteModel);
	WingModel[0].loRotateWithVec(-25.0, 8.0, -15.0, fk_Z, FK_PI/16.0);
	WingModel[1].loRotateWithVec(25.0, -8.0, 15.0, fk_Z, -FK_PI/16.0);
	TailWingModel[0].loRotateWithVec(-6.0, 12.5, 15.0, fk_X, FK_PI/16.0);
	TailWingModel[1].loRotateWithVec(6.0, -12.5, -15.0, fk_X, FK_PI/16.0);

	return;
}

// Gg[֐
void PlugChan::entry(fkut_SimpleWindow &argWin)
{
	argWin.entry(RabbitModel);
	argWin.entry(HeadModel);
	argWin.entry(BodyModel);
	argWin.entry(TailModel);
	//argWin.entry(SilhouetteModel);
	for(int i = 0; i < 2; i++){
		argWin.entry(EarModel[i]);
		argWin.entry(ArmModel[i]);
		argWin.entry(LegModel[i]);
		argWin.entry(EyeModel[i]);
		//argWin.entry(WingModel[i]);
		//argWin.entry(TailWingModel[i]);
	}

	return;
}

void PlugChan::specialAttack(void)
{
	cout << "낯Ƃρ`񂿁" << endl;
}

void PlugChan::update(void)
{
	return;
}
